/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.63 by edhill, Fri Jan 23 16:12:45 2004 UTC revision 1.134 by edhill, Wed Nov 9 04:31:30 2005 UTC
# Line 37  test_for_string_in_file() { Line 37  test_for_string_in_file() {
37      grep -i "$strng" $file > /dev/null 2>&1      grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo -n "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
41          grep -i "$strng" $file          grep -i "$strng" $file
42          return 1          return 1
43      fi      fi
# Line 67  expand_pkg_groups() { Line 67  expand_pkg_groups() {
67          done          done
68          PACKAGES=$new_packages          PACKAGES=$new_packages
69          rm -f ./p[1,2].tmp          rm -f ./p[1,2].tmp
70            return $matched
71      else      else
72          echo "Warning: can't read package groups definition file: $PKG_GROUPS"          echo "Warning: can't read package groups definition file: $PKG_GROUPS"
73      fi      fi
74  }  }
75    
76    #  Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
77    #  cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
78    check_for_broken_Ff()  {
79        #  Do we have defaults for $FS and/or $FS90 ?
80        tfs=f
81        tfs9=f90
82        if test "x$FS" != x ; then
83            tfs="$FS"
84        fi
85        if test "x$FS90" != x ; then
86            tfs9="$FS90"
87        fi
88    
89        #  First check the ability to create a *.F/.f pair.
90        cat <<EOF >> genmake_hello.F
91          program hello
92          write(*,*) 'hi'
93          stop
94          end
95    EOF
96        cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
97        RETVAL=$?
98        if test "x$RETVAL" != x0 ; then
99            if test "x$FS" = x ; then
100                FS='for'
101                FS90='fr9'
102                check_for_broken_Ff
103            else
104                cat <<EOF 2>&1
105    ERROR: Your file system cannot distinguish between *.F and *.f files
106      (fails the "cp" test) and this program cannot find a suitable
107      replacement extension.  Please try a different build environment or
108      contact the <MITgcm-support@mitgcm.org> list for help.
109    
110    EOF
111                exit -1
112            fi
113            return
114        fi
115        rm -f genmake_hello.*
116    
117        #  Check the ability of ${MAKE} and ${LN} to use the current set
118        #  of extensions.
119        cat <<EOF >> genmake_hello.F
120          program hello
121          write(*,*) 'hi'
122          stop
123          end
124    EOF
125        test -f $MAKEFILE  &&  mv -f $MAKEFILE $MAKEFILE".tst"
126        cat <<EOF >> $MAKEFILE
127    .SUFFIXES:
128    .SUFFIXES: .$tfs .F
129    .F.$tfs:
130            $LN \$< \$@
131    EOF
132        $MAKE "genmake_hello."$tfs > /dev/null 2>&1
133        RETVAL=$?
134        if test "x$RETVAL" != x0 -o ! -f "genmake_hello."$tfs ; then
135            if test "x$FS" = x ; then
136                FS='for'
137                FS90='fr9'
138                check_for_broken_Ff
139            else
140                cat <<EOF 2>&1
141    ERROR: Your file system cannot distinguish between *.F and *.f files
142      (fails the "make/ln" test) and this program cannot find a suitable
143      replacement extension.  Please try a different build environment or
144      contact the <MITgcm-support@mitgcm.org> list for help.
145    
146    EOF
147                exit -1
148                return
149            fi
150        fi
151        rm -f genmake_hello.* $MAKEFILE
152        test -f $MAKEFILE".tst"  &&  mv -f $MAKEFILE".tst" $MAKEFILE
153    
154        #  If we make it here, use the extensions
155        FS=$tfs
156        FS90=$tfs9
157        return
158    }
159    
160    
161    look_for_makedepend()  {
162    
163        #  The "original" makedepend is part of the Imake system that is
164        #  most often distributed with XFree86 or with an XFree86 source
165        #  package.  As a result, many machines (eg. generic Linux) do not
166        #  have a system-default "makedepend" available.  For those
167        #  systems, we have two fall-back options:
168        #
169        #    1) a makedepend implementation shipped with the cyrus-imapd
170        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
171        #
172        #    2) a known-buggy xmakedpend shell script
173        #
174        #  So the choices are, in order:
175        #
176        #    1) use the user-specified program
177        #    2) use a system-wide default
178        #    3) locally build and use the cyrus implementation
179        #    4) fall back to the buggy local xmakedpend script
180        #
181        if test "x${MAKEDEPEND}" = x ; then
182            which makedepend > /dev/null 2>&1
183            RV0=$?
184            test -f $MAKEFILE  &&  mv -f $MAKEFILE $MAKEFILE".tst"
185            #  echo 'MAKEFILE="'$MAKEFILE'"'
186            cat <<EOF >> $MAKEFILE
187    #   THIS IS A TEST MAKEFILE GENERATED BY "genmake2"
188    #
189    #   Some "makedepend" implementations will die if they cannot
190    #   find a Makefile -- so this file is here to gives them an
191    #   empty one to find and parse.
192    EOF
193            cat <<EOF >> genmake_tc.f
194          program test
195          write(*,*) 'test'
196          stop
197          end
198    EOF
199            makedepend genmake_tc.f > /dev/null 2>&1
200            RV1=$?
201            test -f $MAKEFILE  &&  rm -f $MAKEFILE
202            test -f $MAKEFILE".tst"  &&  mv -f $MAKEFILE".tst" $MAKEFILE
203            if test "x${RV0}${RV1}" = x00 ; then
204                MAKEDEPEND=makedepend
205            else
206                echo "    a system-default makedepend was not found."
207                
208                #  Try to build the cyrus implementation
209                build_cyrus_makedepend
210                RETVAL=$?
211                if test "x$RETVAL" != x0 ; then
212                    MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
213                fi
214                rm -f ./genmake_cy_md
215            fi
216        else
217            #  echo "MAKEDEPEND=${MAKEDEPEND}"
218            echo "${MAKEDEPEND}" | grep -i cyrus > /dev/null 2>&1
219            RETVAL=$?
220            if test x"$RETVAL" = x0 ; then
221                build_cyrus_makedepend
222            fi
223        fi
224    }
225    
226    
227    build_cyrus_makedepend()  {
228        rm -f ./genmake_cy_md
229        (
230            cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
231                &&  ./configure > /dev/null 2>&1  \
232                &&  make > /dev/null 2>&1
233            if test -x ./makedepend.exe ; then
234                $LN ./makedepend.exe ./makedepend
235            fi
236            ./makedepend ifparser.c > /dev/null 2>&1  \
237                &&  echo "true"
238        ) > ./genmake_cy_md
239        grep true ./genmake_cy_md > /dev/null 2>&1
240        RETVAL=$?
241        rm -f ./genmake_cy_md
242        if test "x$RETVAL" = x0 ; then
243            MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
244            return 0
245        else
246            echo "WARNING: unable to build cyrus-imapd-makedepend"
247            return 1
248        fi
249    }
250    
251  # Guess possible config options for this host  # Guess possible config options for this host
252  find_possible_configs()  {  find_possible_configs()  {
253    
# Line 80  find_possible_configs()  { Line 256  find_possible_configs()  {
256      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
257      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
258      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
259      PLATFORM=$tmp2      tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
260        PLATFORM=$tmp3
261        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
262      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
263      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
264            
# Line 100  find_possible_configs()  { Line 278  find_possible_configs()  {
278          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
279      fi      fi
280    
281      # makedepend is not always available      look_for_makedepend
282      if test "x${MAKEDEPEND}" = x ; then  
283        which makedepend >& /dev/null      #================================================================
284        RETVAL=$?      #  look for possible C compilers
285        if test "x${RETVAL}" = x1 ; then      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"
286           echo "    makedepend was not found. Using xmakedpend instead."      p_CC=
287           MAKEDEPEND='$(TOOLSDIR)/xmakedepend'      for c in $tmp ; do
288        fi          rm -f ./genmake_hello.c  ./genmake_hello
289            cat >> genmake_hello.c << EOF
290    #include <stdio.h>
291    int main(int argc, char **argv) {
292      printf("Hello!\n");
293      return 0;
294    }
295    EOF
296            $c -o genmake_hello genmake_hello.c > /dev/null 2>&1
297            RETVAL=$?
298            if test "x${RETVAL}" = x0 ; then
299                p_CC="$p_CC $c"
300            fi
301        done
302        rm -f ./genmake_hello.c ./genmake_hello
303        if test "x${p_CC}" = x ; then
304            cat 1>&2 <<EOF
305    
306    Error: No C compilers were found in your path.  Please specify one using:
307    
308        1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
309        2) the CC or MITGCM_CC environment variables.
310    
311    EOF
312            exit 1
313        else
314            echo "  The possible C compilers found in your path are:"
315            echo "   "$p_CC
316            if test "x$CC" = x ; then
317                CC=`echo $p_CC | $AWK '{print $1}'`
318                echo "  Setting C compiler to: "$CC
319            fi
320      fi      fi
321    
322      # look for possible fortran compilers      #================================================================
323      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      #  look for possible FORTRAN compilers
324        tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95 gfortran"
325      p_FC=      p_FC=
326      for c in $tmp ; do      for c in $tmp ; do
327          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 136  Error: No Fortran compilers were found i Line 346  Error: No Fortran compilers were found i
346    
347      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
348      2) a command-line option (eg. "-fc NAME"), or      2) a command-line option (eg. "-fc NAME"), or
349      3) the MITGCM_FC environment variable.      3) the FC or MITGCM_FC environment variables.
350    
351  EOF  EOF
352          exit 1          exit 1
# Line 145  EOF Line 355  EOF
355          echo "   "$p_FC          echo "   "$p_FC
356          if test "x$FC" = x ; then          if test "x$FC" = x ; then
357              FC=`echo $p_FC | $AWK '{print $1}'`              FC=`echo $p_FC | $AWK '{print $1}'`
358                echo "  Setting FORTRAN compiler to: "$FC
359          fi          fi
360      fi      fi
361    
362      for i in $p_FC ; do      if test "x$OPTFILE" = x ; then
363          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i          OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
364          if test -r $p_OF ; then          if test ! -r $OPTFILE ; then
365              OPTFILE=$p_OF               echo "  I looked for the file "$OPTFILE" but did not find it"
366              echo "  The options file:  $p_OF"          fi
367              echo "    appears to match so we'll use it."      fi
368              break  #    echo "  The options file:  $p_OF"
369          fi  #    echo "    appears to match so we'll use it."
370      done  #   for i in $p_FC ; do
371    #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
372    #if test -r $p_OF ; then
373    #    OPTFILE=$p_OF
374    #    echo "  The options file:  $p_OF"
375    #    echo "    appears to match so we'll use it."
376    #    break
377    #fi
378    #   done
379      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
380          cat 1>&2 <<EOF          cat 1>&2 <<EOF
381    
# Line 215  get_pdepend_list()  { Line 434  get_pdepend_list()  {
434      . ./.pd_tmp      . ./.pd_tmp
435      rm -f ./.pd_tmp      rm -f ./.pd_tmp
436    
437      echo -n "PNAME = "${}      printf "PNAME = "${}
438  }  }
439    
440    
# Line 229  Usage: "$0" [OPTIONS] Line 448  Usage: "$0" [OPTIONS]
448      -help | --help | -h | --h      -help | --help | -h | --h
449            Print this help message and exit.            Print this help message and exit.
450    
451        -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
452          -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
453              Use "NAME" as the adoptfile.  By default, the file at
454              "tools/adjoint_options/adjoint_default" will be used.
455    
456      -nooptfile | --nooptfile      -nooptfile | --nooptfile
457        -optfile NAME | --optfile NAME | -of NAME | --of NAME        -optfile NAME | --optfile NAME | -of NAME | --of NAME
458        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
# Line 253  Usage: "$0" [OPTIONS] Line 477  Usage: "$0" [OPTIONS]
477        --makefile=NAME | -mf=NAME        --makefile=NAME | -mf=NAME
478            Call the makefile "NAME".  The default is "Makefile".            Call the makefile "NAME".  The default is "Makefile".
479    
480        -makedepend NAME | -md NAME
481          --makedepend=NAME | -md=NAME
482              Use "NAME" for the MAKEDEPEND program.
483    
484      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
485        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
486            Specify the location of the MITgcm ROOTDIR as "NAME".            Specify the location of the MITgcm ROOTDIR as "NAME".
# Line 289  Usage: "$0" [OPTIONS] Line 517  Usage: "$0" [OPTIONS]
517            will search for a working compiler by trying a list of            will search for a working compiler by trying a list of
518            "usual suspects" such as g77, f77, etc.            "usual suspects" such as g77, f77, etc.
519    
520        -cc NAME | --cc NAME | -cc=NAME | --cc=NAME
521              Use "NAME" as the C compiler.  By default, genmake
522              will search for a working compiler by trying a list of
523              "usual suspects" such as gcc, c89, cc, etc.
524    
525      -[no]ieee | --[no]ieee      -[no]ieee | --[no]ieee
526            Do or don't use IEEE numerics.  Note that this option            Do or don't use IEEE numerics.  Note that this option
527            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
528            is being used.            is being used.
529    
530        -ts | --ts
531              Produce timing information per timestep
532    
533        -mpi | --mpi
534              Include MPI header files and link to MPI libraries
535        -mpi=PATH | --mpi=PATH
536              Include MPI header files and link to MPI libraries using MPI_ROOT
537              set to PATH. i.e. Include files from \$PATH/include, link to libraries
538              from \$PATH/lib and use binaries from \$PATH/bin.
539    
540        -bash NAME
541              Explicitly specify the Bourne or BASH shell to use
542    
543    While it is most often a single word, the "NAME" variables specified    While it is most often a single word, the "NAME" variables specified
544    above can in many cases be a space-delimited string such as:    above can in many cases be a space-delimited string such as:
545    
# Line 314  EOF Line 560  EOF
560    
561  #  Build a CPP macro to automate calling C routines from FORTRAN  #  Build a CPP macro to automate calling C routines from FORTRAN
562  get_fortran_c_namemangling()  {  get_fortran_c_namemangling()  {
563    
564        #echo "FC_NAMEMANGLE = \"$FC_NAMEMANGLE\""
565        if test ! "x$FC_NAMEMANGLE" = x ; then
566            return 0
567        fi
568    
569      default_nm="#define FC_NAMEMANGLE(X) X ## _"      default_nm="#define FC_NAMEMANGLE(X) X ## _"
570            
571      cat > genmake_test.c <<EOF      cat > genmake_test.c <<EOF
# Line 331  WARNING: Please contact <MITgcm-support@ Line 583  WARNING: Please contact <MITgcm-support@
583  EOF  EOF
584          return 1          return 1
585      fi      fi
586      c_tcall=`nm genmake_test.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`      c_tcall=`nm genmake_test.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
587      RETVAL=$?      RETVAL=$?
588      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
589          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 343  WARNING: Please contact <MITgcm-support@ Line 595  WARNING: Please contact <MITgcm-support@
595  EOF  EOF
596          return 1          return 1
597      fi      fi
598      cat > genmake_tcomp.f <<EOF      cat > genmake_tcomp.$FS <<EOF
599        subroutine tcall( string )        subroutine tcall( string )
600        character*(*) string        character*(*) string
601        call tsub( string )        call tsub( string )
602        end        end
603  EOF  EOF
604      $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1      $FC $FFLAGS -c genmake_tcomp.$FS >> genmake_warnings 2>&1
605      RETVAL=$?      RETVAL=$?
606      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
607          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 361  WARNING: Please contact <MITgcm-support@ Line 613  WARNING: Please contact <MITgcm-support@
613  EOF  EOF
614          return 1          return 1
615      fi      fi
616      f_tcall=`nm genmake_tcomp.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`      f_tcall=`nm genmake_tcomp.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
617      RETVAL=$?      RETVAL=$?
618      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
619          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 415  void FC_NAMEMANGLE(cloc) ( double *curti Line 667  void FC_NAMEMANGLE(cloc) ( double *curti
667   *curtim = *curtim/1.E6;   *curtim = *curtim/1.E6;
668  }  }
669  EOF  EOF
670      make genmake_tc_1.o >> genmake_tc.log 2>&1      make genmake_tc_1.o >> genmake_warnings 2>&1
671      RET_C=$?      RET_C=$?
672      cat <<EOF > genmake_tc_2.f      cat <<EOF > genmake_tc_2.$FS
673        program hello        program hello
674        Real*8 wtime        REAL*8 wtime
675        external cloc        external cloc
676        call cloc(wtime)        call cloc(wtime)
677        print *," HELLO WORLD", wtime        print *," HELLO WORLD", wtime
678        end program hello        end
679  EOF  EOF
680      $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1      $FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o >> genmake_warnings 2>&1
681      RET_F=$?      RET_F=$?
682      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1
683      RETVAL=$?      RETVAL=$?
684      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
685          HAVE_CLOC=t          HAVE_CLOC=t
# Line 437  EOF Line 689  EOF
689  }  }
690    
691    
692    check_HAVE_SETRLSTK()  {
693        get_fortran_c_namemangling
694        cat <<EOF > genmake_tc_1.c
695    $FC_NAMEMANGLE
696    #include <sys/time.h>
697    #include <sys/resource.h>
698    #include <unistd.h>
699    void FC_NAMEMANGLE(setrlstk) ()
700    {
701        struct rlimit rls;
702        rls.rlim_cur = RLIM_INFINITY;
703        rls.rlim_max = RLIM_INFINITY;
704        setrlimit(RLIMIT_STACK, &rls);
705        return;
706    }
707    EOF
708        make genmake_tc_1.o >> genmake_warnings 2>&1
709        RET_C=$?
710        cat <<EOF > genmake_tc_2.$FS
711          program hello
712          external setrlstk
713          call setrlstk()
714          end
715    EOF
716        $FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o >> genmake_warnings 2>&1
717        RET_F=$?
718        test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1
719        RETVAL=$?
720        if test "x$RETVAL" = x0 ; then
721            HAVE_SETRLSTK=t
722            DEFINES="$DEFINES -DHAVE_SETRLSTK"
723        fi
724        rm -f genmake_tc*
725    }
726    
727    
728    check_HAVE_STAT()  {
729        get_fortran_c_namemangling
730        cat <<EOF > genmake_tc_1.c
731    $FC_NAMEMANGLE
732    #include <stdio.h>
733    #include <stdlib.h>
734    #include <unistd.h>
735    #include <sys/stat.h>
736    #include <sys/types.h>
737    void FC_NAMEMANGLE(tfsize) ( int *nbyte )
738    {
739        char name[512];
740        struct stat astat;
741    
742        name[0] = 'a'; name[1] = '\0';
743        if (! stat(name, &astat))
744            *nbyte = (int)(astat.st_size);
745        else
746            *nbyte = -1;
747    }
748    EOF
749        make genmake_tc_1.o >> genmake_tc.log 2>&1
750        RET_C=$?
751        cat <<EOF > genmake_tc_2.$FS
752          program hello
753          integer nbyte
754          call tfsize(nbyte)
755          print *," HELLO WORLD", nbyte
756          end
757    EOF
758        $FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o >> genmake_tc.log 2>&1
759        RET_F=$?
760        test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1
761        RETVAL=$?
762        if test "x$RETVAL" = x0 ; then
763            HAVE_STAT=t
764            DEFINES="$DEFINES -DHAVE_STAT"
765        fi
766        rm -f genmake_tc*
767    }
768    
769    
770  check_netcdf_libs()  {  check_netcdf_libs()  {
771        if test ! "x$SKIP_NETCDF_CHECK" = x ; then
772            return
773        fi
774        echo "" > genmake_tnc.log
775      cat <<EOF > genmake_tnc.F      cat <<EOF > genmake_tnc.F
776        program fgennc        program fgennc
777  #include "netcdf.inc"  #include "netcdf.inc"
778    EOF
779        if test ! "x$MPI" = x ; then
780            echo '#include "mpif.h"' >> genmake_tnc.F
781        fi
782        cat <<EOF >> genmake_tnc.F
783        integer iret, ncid, xid        integer iret, ncid, xid
784        iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)        iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
785        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
# Line 450  check_netcdf_libs()  { Line 789  check_netcdf_libs()  {
789        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
790        end        end
791  EOF  EOF
792      $CPP genmake_tnc.F > genmake_tnc.f  \      echo "Executing:" > genmake_tnc.log
793          &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1      echo "  $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS" \
794            >> genmake_tnc.log
795        RET_CPP=f
796        $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS 2>/dev/null  \
797            &&  RET_CPP=t
798        if test "x$RET_CPP" = xf ; then
799            echo "  WARNING: CPP failed to pre-process the netcdf test." \
800                >> genmake_tnc.log
801            echo "    Please check that \$INCLUDES is properly set." \
802                >> genmake_tnc.log
803        fi
804        echo "Executing:" > genmake_tnc.log
805        echo "  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS" >> genmake_tnc.log
806        echo "  $LINK -o genmake_tnc.o $LIBS" >> genmake_tnc.log
807        $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
808            &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
809      RET_COMPILE=$?      RET_COMPILE=$?
810      test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1  
811      RETVAL=$?      #EH3  Remove test program execution for machines that either disallow
812      if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then      #EH3  execution or cannot support it (eg. cross-compilers)
813        #EH3
814        #EH3 test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
815        #EH3 RETVAL=$?
816        #EH3 if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
817    
818        if test "x$RET_COMPILE" = x0 ; then
819          HAVE_NETCDF=t          HAVE_NETCDF=t
820      else      else
821          cat genmake_tnc.log >> genmake_warnings          # try again with "-lnetcdf" added to the libs
822            echo "$CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS \ " >> genmake_tnc.log
823            echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
824            echo " &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
825            $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS 2>/dev/null  \
826                &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
827                &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
828            RET_COMPILE=$?
829            if test "x$RET_COMPILE" = x0 ; then
830                LIBS="$LIBS -lnetcdf"
831                HAVE_NETCDF=t
832            else
833                echo "===  genmake_tnc.F  ===" >> genmake_warnings
834                cat genmake_tnc.F >> genmake_warnings
835                echo "===  genmake_tnc.F  ===" >> genmake_warnings
836                cat genmake_tnc.log >> genmake_warnings
837            fi
838      fi      fi
839      rm -f genmake_tnc*      rm -f genmake_tnc*
840  }  }
841    
842    
843    
844    ###############################################################################
845    #   Sequential part of script starts here
846    ###############################################################################
847    
848  #  Set defaults here  #  Set defaults here
849  COMMANDL="$0 $@"  COMMANDL="$0 $@"
850    
# Line 471  PLATFORM= Line 852  PLATFORM=
852  LN=  LN=
853  S64=  S64=
854  KPP=  KPP=
855  FC=  #FC=
856  CPP=  #CC=gcc
857    #CPP=
858  LINK=  LINK=
 # DEFINES="-DWORDLENGTH=4"  
859  DEFINES=  DEFINES=
860  PACKAGES=  PACKAGES=
861  ENABLE=  ENABLE=
862  DISABLE=  DISABLE=
863  MAKEFILE=  # MAKEFILE=
864  MAKEDEPEND=  # MAKEDEPEND=
865  PDEPEND=  PDEPEND=
866  DUMPSTATE=t  DUMPSTATE=t
867  PDEFAULT=  PDEFAULT=
868  OPTFILE=  OPTFILE=
869  INCLUDES="-I."  INCLUDES="-I. $INCLUDES"
870  FFLAGS=  FFLAGS=
871  FOPTIM=  FOPTIM=
872  CFLAGS=  CFLAGS=
873  KFLAGS1=  KFLAGS1=
874  KFLAGS2=  KFLAGS2=
875    #LDADD=
876  LIBS=  LIBS=
877  KPPFILES=  KPPFILES=
878  NOOPTFILES=  NOOPTFILES=
879  NOOPTFLAGS=  NOOPTFLAGS=
880    MPI=
881    MPIPATH=
882    TS=
883    HAVE_TEST_L=
884    
885  # DEFINES checked by test compilation  # DEFINES checked by test compilation or command-line
886  HAVE_SYSTEM=  HAVE_SYSTEM=
887  HAVE_FDATE=  HAVE_FDATE=
888  FC_NAMEMANGLE=  FC_NAMEMANGLE=
889  HAVE_CLOC=  HAVE_CLOC=
890    HAVE_SETRLSTK=
891    HAVE_STAT=
892  HAVE_NETCDF=  HAVE_NETCDF=
893    HAVE_ETIME=
894    IGNORE_TIME=
895    
896  MODS=  MODS=
897  TOOLSDIR=  TOOLSDIR=
# Line 509  SOURCEDIRS= Line 899  SOURCEDIRS=
899  INCLUDEDIRS=  INCLUDEDIRS=
900  STANDARDDIRS="USE_THE_DEFAULT"  STANDARDDIRS="USE_THE_DEFAULT"
901    
902    G2ARGS=
903    BASH=
904  PWD=`pwd`  PWD=`pwd`
905  MAKE=make  test "x$MAKE" = x  &&  MAKE=make
906  AWK=awk  test "x$AWK" = x   &&  AWK=awk
907  THISHOSTNAME=`hostname`  THISHOST=`hostname`
908  THISCWD=`pwd`  THISCWD=`pwd`
909  THISDATE=`date`  THISDATE=`date`
910    THISUSER=`echo $USER`
911    THISVER=
912  MACHINE=`uname -a`  MACHINE=`uname -a`
913  EXECUTABLE=  EXECUTABLE=
914  EXEHOOK=  EXEHOOK=
# Line 524  IEEE= Line 918  IEEE=
918  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
919      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
920  fi  fi
921    FS=
922    FS90=
923    
924  AUTODIFF_PKG_USED=f  AUTODIFF_PKG_USED=f
925  AD_OPTFILE=  AD_OPTFILE=
# Line 541  TAMC_EXTRA= Line 937  TAMC_EXTRA=
937    
938  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
939  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
940  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE TS MPI JAM DUMPSTATE STANDARDDIRS"
941    
942  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
943  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
944  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
945  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
946  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
947  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
948    
949  #  The following are all related to adjoint/tangent-linear stuff  #  The following are all related to adjoint/tangent-linear stuff
950  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
# Line 577  for i in . $MODS ; do Line 973  for i in . $MODS ; do
973          break          break
974      fi      fi
975  done  done
976  echo -n "  getting local config information:  "  printf "  getting local config information:  "
977  if test -e $gm_local ; then  if test -f $gm_local ; then
978      echo "using $gm_local"      echo "using $gm_local"
979      . $gm_local      . $gm_local
980      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
# Line 587  else Line 983  else
983      echo "none found"      echo "none found"
984  fi  fi
985    
986  #  echo "$0::$1:$2:$3:$4:$5:$6:$7:"  #echo "$0::$1:$2:$3:$4:$5:$6:$7:"
987  #OPTIONS=  #OPTIONS=
988  #n=0  #n=0
989  #for i ; do  #for i ; do
# Line 599  fi Line 995  fi
995  #done  #done
996  #parse_options  #parse_options
997  ac_prev=  ac_prev=
998  for ac_option ; do  for ac_option in "$@" ; do
999    
1000        G2ARGS="$G2ARGS \"$ac_option\""
1001    
1002      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
1003      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
# Line 642  for ac_option ; do Line 1040  for ac_option ; do
1040          -make=* | --make=* | -m=* | --m=*)          -make=* | --make=* | -m=* | --m=*)
1041              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
1042                    
1043            -bash | --bash)
1044                ac_prev=BASH ;;
1045            -bash=* | --bash=*)
1046                BASH=$ac_optarg ;;
1047            
1048            -makedepend | --makedepend | -md | --md)
1049                ac_prev=MAKEDEPEND ;;
1050            -makedepend=* | --makedepend=* | -md=* | --md=*)
1051                MAKEDEPEND=$ac_optarg ;;
1052            
1053          -makefile | --makefile | -ma | --ma)          -makefile | --makefile | -ma | --ma)
1054              ac_prev=MAKEFILE ;;              ac_prev=MAKEFILE ;;
1055          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
# Line 683  for ac_option ; do Line 1091  for ac_option ; do
1091  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
1092  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
1093  #               CPP=$ac_optarg ;;  #               CPP=$ac_optarg ;;
1094                        
1095            -cc | --cc)
1096                ac_prev=CC ;;
1097            -cc=* | --cc=*)
1098                CC=$ac_optarg ;;
1099            
1100          -fortran | --fortran | -fc | --fc)          -fortran | --fortran | -fc | --fc)
1101              ac_prev=FC ;;              ac_prev=FC ;;
1102          -fc=* | --fc=*)          -fc=* | --fc=*)
1103              FC=$ac_optarg ;;              FC=$ac_optarg ;;
1104                    
1105            -fs | --fs)
1106                ac_prev=FS ;;
1107            -fs=* | --fs=*)
1108                FS=$ac_optarg ;;
1109            
1110            -fs90 | --fs90)
1111                ac_prev=FS90 ;;
1112            -fs90=* | --fs90=*)
1113                FS90=$ac_optarg ;;
1114            
1115          -ieee | --ieee)          -ieee | --ieee)
1116              IEEE=true ;;              IEEE=true ;;
1117          -noieee | --noieee)          -noieee | --noieee)
1118              IEEE= ;;              IEEE= ;;
1119    
1120            -ts | --ts)
1121                TS=true ;;
1122    
1123            -mpi | --mpi)
1124                MPI=true ;;
1125            -mpi=* | --mpi=*)
1126                MPIPATH=$ac_optarg
1127                MPI=true ;;
1128                    
1129  #       -jam | --jam)  #       -jam | --jam)
1130  #           JAM=1 ;;  #           JAM=1 ;;
# Line 711  for ac_option ; do Line 1143  for ac_option ; do
1143              ac_prev=TAMC_EXTRA ;;              ac_prev=TAMC_EXTRA ;;
1144          -tamc_extra=* | --tamc_extra=*)          -tamc_extra=* | --tamc_extra=*)
1145              TAMC_EXTRA=$ac_optarg ;;              TAMC_EXTRA=$ac_optarg ;;
1146            
1147            -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1148                IGNORE_TIME="-DIGNORE_TIME" ;;
1149    
1150          -*)          -*)
1151              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
# Line 726  for ac_option ; do Line 1161  for ac_option ; do
1161            
1162  done  done
1163    
1164    
1165  if test -f ./.genmakerc ; then  if test -f ./.genmakerc ; then
1166      echo      echo
1167      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
# Line 738  if test -f ./.genmakerc ; then Line 1174  if test -f ./.genmakerc ; then
1174      echo      echo
1175  fi  fi
1176    
1177    #  Find the MITgcm ${ROOTDIR}
1178  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1179      if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1180        if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
1181          ROOTDIR=".."          ROOTDIR=".."
1182      else      else
1183          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
1184              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
1185                  ROOTDIR=$d                  ROOTDIR=$d
1186                  echo -n "Warning:  ROOTDIR was not specified but there appears to be"                  printf "Warning:  ROOTDIR was not specified but there appears to be"
1187                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
1188                  break                  break
1189              fi              fi
# Line 763  if test ! -d ${ROOTDIR} ; then Line 1201  if test ! -d ${ROOTDIR} ; then
1201      exit 1      exit 1
1202  fi  fi
1203    
1204    #  Find the MITgcm ${THISVER}
1205    if test -f "${ROOTDIR}/doc/tag-index" ; then
1206        THISVER=`grep '^checkpoint' ${ROOTDIR}/doc/tag-index | head -1`
1207    fi
1208    
1209    if test "x$MAKEFILE" = x ; then
1210        MAKEFILE="Makefile"
1211    fi
1212    
1213  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
1214  if test "x${OPTFILE}" = x ; then  if test "x${OPTFILE}" = x ; then
1215      if test "x$MITGCM_OF" = x ; then      if test "x$MITGCM_OF" = x ; then
# Line 779  if test "x$OPTFILE" != xNONE ; then Line 1226  if test "x$OPTFILE" != xNONE ; then
1226          . "$OPTFILE"          . "$OPTFILE"
1227          RETVAL=$?          RETVAL=$?
1228          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1229              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              printf "Error: failed to source OPTFILE \"$OPTFILE\""
1230              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1231              exit 1              exit 1
1232          fi          fi
# Line 806  if test "x${AD_OPTFILE}" != xNONE ; then Line 1253  if test "x${AD_OPTFILE}" != xNONE ; then
1253          . "$AD_OPTFILE"          . "$AD_OPTFILE"
1254          RETVAL=$?          RETVAL=$?
1255          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1256              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1257              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1258              exit 1              exit 1
1259          fi          fi
# Line 819  if test "x${AD_OPTFILE}" != xNONE ; then Line 1266  if test "x${AD_OPTFILE}" != xNONE ; then
1266      fi      fi
1267  fi  fi
1268    
1269  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,  #====================================================================
1270    #  Set default values if not set by the optfile
1271    #
1272    #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1273  #  either set defaults or complain and abort!  #  either set defaults or complain and abort!
1274    if test ! "x$BASH" = x ; then
1275        # add a trailing space so that it works within the Makefile syntax (see below)
1276        BASH="$BASH "
1277    fi
1278  if test "x$FC" = x ; then  if test "x$FC" = x ; then
1279      cat <<EOF 1>&2      cat <<EOF 1>&2
1280    
# Line 831  Error: no Fortran compiler: please speci Line 1285  Error: no Fortran compiler: please speci
1285  EOF  EOF
1286      exit 1      exit 1
1287  fi  fi
1288    if test "x$CC" = x ; then
1289        CC=cc
1290    #     cat <<EOF 1>&2
1291    # Error: no C compiler: please specify using one of the following:
1292    #   1) within the options file ("CC=...") as specified by "-of=OPTFILE"
1293    #   2) the "-cc=XXX" command-line option
1294    #   3) the "./genmake_local" file
1295    # EOF
1296    #     exit 1
1297    fi
1298  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
1299      LINK=$FC      LINK=$FC
1300  fi  fi
# Line 841  if test "x$CPP" = x ; then Line 1305  if test "x$CPP" = x ; then
1305      CPP=cpp      CPP=cpp
1306  fi  fi
1307  #EH3 === UGLY ===  #EH3 === UGLY ===
1308  #  The following an ugly little hack to check for $CPP in /lib/ and it  #  The following is an ugly little hack to check for $CPP in /lib/ and
1309  #  should eventually be replaced with a more general function that  #  it should eventually be replaced with a more general function that
1310  #  searches a combo of the user's path and a list of "usual suspects"  #  searches a combo of the user's path and a list of "usual suspects"
1311  #  to find the correct location for binaries such as $CPP.  #  to find the correct location for binaries such as $CPP.
1312  for i in " " "/lib/" ; do  for i in " " "/lib/" ; do
# Line 865  EOF Line 1329  EOF
1329  else  else
1330      rm -f test_cpp      rm -f test_cpp
1331  fi  fi
1332  if test "x$MAKEDEPEND" = x ; then  look_for_makedepend
     MAKEDEPEND=makedepend  
 fi  
1333  if test "x$LN" = x ; then  if test "x$LN" = x ; then
1334      LN="ln -s"      LN="ln -s"
1335  fi  fi
# Line 883  Error: The command "ln -s" failed -- ple Line 1345  Error: The command "ln -s" failed -- ple
1345  EOF  EOF
1346      exit 1      exit 1
1347  fi  fi
1348    test -L genmake_tlink > /dev/null 2>&1
1349    RETVAL=$?
1350    if test "x$RETVAL" = x0 ; then
1351        HAVE_TEST_L=t
1352    fi
1353  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1354    
1355    #  Check for broken *.F/*.f handling and fix if possible
1356    check_for_broken_Ff
1357    
1358    if test ! "x$MPI" = x ; then
1359          echo "  Turning on MPI cpp macros"
1360          DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1361    fi
1362    
1363    if test ! "x$TS" = x ; then
1364          echo "  Turning on timing per timestep"
1365          DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1366    fi
1367    
1368  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
1369  echo -n "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
1370  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1371        program hello        program hello
1372        call system('echo hi')        call system('echo hi')
1373        end        end
1374  EOF  EOF
1375  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1376  RETVAL=$?  RETVAL=$?
1377  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1378      HAVE_SYSTEM=t      HAVE_SYSTEM=t
# Line 905  else Line 1384  else
1384  fi  fi
1385  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1386    
1387  echo -n "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1388  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1389        program hello        program hello
1390        CHARACTER(128) string        CHARACTER*(128) string
1391        string = ' '        string = ' '
1392        call fdate( string )        call fdate( string )
1393        print *, string        print *, string
1394        end        end
1395  EOF  EOF
1396  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1397  RETVAL=$?  RETVAL=$?
1398  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1399      HAVE_FDATE=t      HAVE_FDATE=t
# Line 926  else Line 1405  else
1405  fi  fi
1406  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1407    
1408  echo -n "  Can we call simple C routines (here, \"cloc()\") using $FC...  "  printf "  Do we have the etime() command using $FC...  "
1409    cat > genmake_tcomp.$FS <<EOF
1410          program hello
1411          REAL*4 ACTUAL, TARRAY(2)
1412          EXTERNAL ETIME
1413          REAL*4 ETIME
1414          actual = etime( tarray )
1415          print *, tarray
1416          end
1417    EOF
1418    $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1419    RETVAL=$?
1420    if test "x$RETVAL" = x0 ; then
1421        HAVE_ETIME=t
1422        DEFINES="$DEFINES -DHAVE_ETIME"
1423        echo "yes"
1424    else
1425        HAVE_ETIME=
1426        echo "no"
1427    fi
1428    rm -f genmake_tcomp*
1429    
1430    printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1431  check_HAVE_CLOC  check_HAVE_CLOC
1432  if test "x$HAVE_CLOC" != x ; then  if test "x$HAVE_CLOC" != x ; then
1433      echo "yes"      echo "yes"
# Line 935  else Line 1436  else
1436  fi  fi
1437  rm -f genmake_t*  rm -f genmake_t*
1438    
1439  echo -n "  Can we create NetCDF-enabled binaries...  "  printf "  Can we unlimit the stack size using $FC...  "
1440    check_HAVE_SETRLSTK
1441    if test "x$HAVE_SETRLSTK" != x ; then
1442        echo "yes"
1443    else
1444        echo "no"
1445    fi
1446    rm -f genmake_t*
1447    
1448    printf "  Can we use stat() through C calls...  "
1449    check_HAVE_STAT
1450    if test "x$HAVE_STAT" != x ; then
1451        echo "yes"
1452    else
1453        echo "no"
1454    fi
1455    rm -f genmake_t*
1456    
1457    printf "  Can we create NetCDF-enabled binaries...  "
1458  check_netcdf_libs  check_netcdf_libs
1459  if test "x$HAVE_NETCDF" != x ; then  if test "x$HAVE_NETCDF" != x ; then
1460      echo "yes"      echo "yes"
1461  else  else
1462      echo "no"      echo "no"
1463  fi  fi
1464    DEFINES="$DEFINES $IGNORE_TIME"
1465    
1466  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1467  echo -n "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1468  for d in $MODS ; do  for d in $MODS ; do
1469      if test ! -d $d ; then      if test ! -d $d ; then
1470          echo          echo
1471          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1472          exit 1          exit 1
1473      else      else
1474          echo -n " $d"          printf " $d"
1475          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1476          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1477      fi      fi
1478  done  done
1479  echo  echo
1480    
 if test "x$MAKEFILE" = x ; then  
     MAKEFILE="Makefile"  
 fi  
1481  if test "x${PLATFORM}" = x ; then  if test "x${PLATFORM}" = x ; then
1482      PLATFORM=$p_PLATFORM      PLATFORM=$p_PLATFORM
1483  fi  fi
1484    
1485  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
1486      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1487        if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1488          EXEDIR=../exe          EXEDIR=../exe
1489      else      else
1490          EXEDIR=.          EXEDIR=.
# Line 982  if test "x${TOOLSDIR}" = x ; then Line 1499  if test "x${TOOLSDIR}" = x ; then
1499      TOOLSDIR="$ROOTDIR/tools"      TOOLSDIR="$ROOTDIR/tools"
1500  fi  fi
1501  if test ! -d ${TOOLSDIR} ; then  if test ! -d ${TOOLSDIR} ; then
1502      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1503      exit 1      exit 1
1504  fi  fi
1505  if test "x$S64" = x ; then  if test "x$S64" = x ; then
1506      S64='$(TOOLSDIR)/set64bitConst.sh'      echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.sh > /dev/null 2>&1
1507        RETVAL=$?
1508        if test "x${RETVAL}" = x0 ; then
1509            S64='$(TOOLSDIR)/set64bitConst.sh'
1510        else
1511            echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.csh > /dev/null 2>&1
1512            RETVAL=$?
1513            if test "x${RETVAL}" = x0 ; then
1514                S64='$(TOOLSDIR)/set64bitConst.csh'
1515            else
1516                cat <<EOF
1517    
1518    ERROR: neither of the two default scripts:
1519    
1520        ${TOOLSDIR}/set64bitConst.sh
1521        ${TOOLSDIR}/set64bitConst.csh
1522    
1523      are working so please check paths or specify (with \$S64) a
1524      working version of this script.
1525    
1526    EOF
1527                exit 1
1528            fi
1529        fi
1530  fi  fi
1531  THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`  THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1532    
# Line 1077  else Line 1617  else
1617          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1618          RETVAL=$?          RETVAL=$?
1619          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1620              echo -n "Error: can't parse default package list "              printf "Error: can't parse default package list "
1621              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PDEFAULT=\"$PDEFAULT\""
1622              exit 1              exit 1
1623          fi          fi
# Line 1085  else Line 1625  else
1625              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1626          done          done
1627          echo "    before group expansion packages are: $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1628          expand_pkg_groups          RET=1
1629            while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1630          echo "    after group expansion packages are:  $PACKAGES"          echo "    after group expansion packages are:  $PACKAGES"
1631      fi      fi
1632  fi  fi
1633    
1634  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1635    for i in $PACKAGES ; do
1636        echo $i >> ./.tmp_pack
1637    done
1638    for i in `grep  "-" ./.tmp_pack` ; do
1639        j=`echo $i | sed 's/[-]//'`
1640        DISABLE="$DISABLE $j"
1641    done
1642  pack=  pack=
1643  for p in $PACKAGES ; do  for p in $PACKAGES ; do
1644      addit="t"      addit="t"
# Line 1107  PACKAGES="$pack" Line 1655  PACKAGES="$pack"
1655  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1656  echo "" > ./.tmp_pack  echo "" > ./.tmp_pack
1657  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1658    # Test if each explicitly referenced package exists
1659  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1660      if test ! -d "$ROOTDIR/pkg/$i" ; then      j=`echo $i | sed 's/[-+]//'`
1661        if test ! -d "$ROOTDIR/pkg/$j" ; then
1662          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1663          exit 1          exit 1
1664      fi      fi
1665      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
1666  done  done
 pack=`cat ./.tmp_pack | sort | uniq`  
 rm -f ./.tmp_pack  
1667  PACKAGES=  PACKAGES=
1668  for i in $pack ; do  for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1669      PACKAGES="$PACKAGES $i"      PACKAGES="$PACKAGES $i"
1670  done  done
1671    rm -f ./.tmp_pack
1672  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1673    
1674    #  Check availability of NetCDF and then either build the MNC template
1675    #  files or delete mnc from the list of available packages.
1676    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1677    RETVAL=$?
1678    if test "x$RETVAL" = x0 ; then
1679        if test "x$HAVE_NETCDF" != xt ; then
1680            cat <<EOF
1681    
1682    *********************************************************************
1683    WARNING: the "mnc" package was enabled but tests failed to compile
1684      NetCDF applications.  Please check that:
1685    
1686      1) NetCDF is correctly installed for this compiler and
1687      2) the LIBS variable (within the "optfile") specifies the correct
1688           NetCDF library to link against.
1689    
1690      Due to this failure, the "mnc" package is now DISABLED.
1691    *********************************************************************
1692    
1693    EOF
1694            PACKAGES=`echo $PACKAGES | sed -e 's/mnc//g'`
1695            DISABLE="$DISABLE mnc"
1696        else
1697            ( cd $ROOTDIR"/pkg/mnc" && $MAKE testclean && $MAKE templates ) > make_mnc.errors 2>&1
1698            RETVAL=$?
1699            if test "x${RETVAL}" = x0 ; then
1700                rm -f make_mnc.errors
1701            else
1702                echo "Error: problem encountered while building source files in pkg/mnc:"
1703                cat make_mnc.errors 1>&2
1704                exit 1
1705            fi
1706        fi
1707    fi
1708    
1709  echo "  applying package dependency rules"  echo "  applying package dependency rules"
1710  ck=  ck=
1711  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
# Line 1186  while test "x$ck" != xtt ; do Line 1770  while test "x$ck" != xtt ; do
1770              echo "  the dependency rules for \"$dname\""              echo "  the dependency rules for \"$dname\""
1771              exit 1              exit 1
1772          fi          fi
1773          i=$(( $i + 1 ))          i=`echo "$i + 1" | bc -l`
1774            #i=$(( $i + 1 ))
1775      done      done
1776      ck=$ck"t"      ck=$ck"t"
1777  done  done
# Line 1205  for i in $PACKAGES ; do Line 1790  for i in $PACKAGES ; do
1790      fi      fi
1791  done  done
1792    
 #  Build MNC templates and check for ability to build and use NetCDF  
 echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1  
 RETVAL=$?  
 if test "x$RETVAL" = x0 ; then  
     ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1  
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         rm -f make_mnc.errors  
     else  
         echo "Error: problem encountered while building source files in pkg/mnc:"  
         cat make_mnc.errors 1>&2  
         exit 1  
     fi  
     if test -a "x$HAVE_NETCDF" != xt ; then  
         cat <<EOF  
   
 WARNING: the "mnc" package has been enabled but tests failed to  
   compile and/or execute NetCDF applications.  Please check that:  
   
   1) NetCDF is installed for your compiler and  
   2) the LIBS variable (within the 'optfile") specifies the correct  
        NetCDF library to link against.  
     
 EOF  
     fi  
 fi  
   
1793  # Create a list of #define and #undef to enable/disable packages  # Create a list of #define and #undef to enable/disable packages
1794  PACKAGES_DOT_H=PACKAGES_CONFIG.h  PACKAGES_DOT_H=PACKAGES_CONFIG.h
1795  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
# Line 1251  for n in $names ; do Line 1809  for n in $names ; do
1809              fi              fi
1810          done          done
1811          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1812              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
1813              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
1814          fi          fi
1815      fi      fi
1816  done  done
1817  ENABLED_PACKAGES=  ENABLED_PACKAGES=
1818  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1819      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`      def=`echo "ALLOW_$i" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
1820      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
1821  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
1822    
# Line 1342  for i in $SOURCEDIRS ; do Line 1900  for i in $SOURCEDIRS ; do
1900          cat $i/$j >> ad_files          cat $i/$j >> ad_files
1901      done      done
1902  done  done
1903    if test ! "x"$FS = "x.f" ; then
1904        cat ad_files | sed -e "s/\.f/.$FS/g" > ad_files_f
1905        mv -f ad_files_f ad_files
1906    fi
1907    
1908  echo  echo
1909  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1910  echo "  setting INCLUDES"  echo "  setting INCLUDES"
1911  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
1912      if ! test -d $i ; then      if test ! -d $i ; then
 #       INCLUDES="$INCLUDES -I$i"  
 #   else  
1913          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
1914      fi      fi
1915  done  done
# Line 1360  rm -rf .links.tmp Line 1919  rm -rf .links.tmp
1919  mkdir .links.tmp  mkdir .links.tmp
1920  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
1921  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
1922  echo -n 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
1923  echo -n 'CSRCFILES = '   > csrclist.inc  printf 'CSRCFILES = '   > csrclist.inc
1924  echo -n 'F90SRCFILES = ' > f90srclist.inc  printf 'F90SRCFILES = ' > f90srclist.inc
1925  echo -n 'HEADERFILES = ' > hlist.inc  printf 'HEADERFILES = ' > hlist.inc
1926  echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
1927  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1928  for d in $alldirs ; do  for d in $alldirs ; do
1929      deplist=      deplist=
# Line 1373  for d in $alldirs ; do Line 1932  for d in $alldirs ; do
1932      for sf in $sfiles ; do      for sf in $sfiles ; do
1933          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1934              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1935                    ignore_f=f
1936                  case $d/$sf in                  case $d/$sf in
1937                    ./$PACKAGES_DOT_H)                    ./$PACKAGES_DOT_H)
1938                          ;;                          ;;
# Line 1380  for d in $alldirs ; do Line 1940  for d in $alldirs ; do
1940                          ;;                          ;;
1941                    ./FC_NAMEMANGLE.h)                    ./FC_NAMEMANGLE.h)
1942                          ;;                          ;;
1943                      ./BUILD_INFO.h)
1944                            ;;
1945                    *)                    *)
1946                          touch .links.tmp/$sf                          #  For the local directory *ONLY*,
1947                          deplist="$deplist $sf"                          #  ignore all soft-links
1948                            if test "x$HAVE_TEST_L" = xt -a "x$d" = x. -a -L $sf ; then
1949                                ignore_f=t
1950                            else
1951                                touch .links.tmp/$sf
1952                                deplist="$deplist $sf"
1953                            fi
1954                          ;;                          ;;
1955                  esac                  esac
1956                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`                  if test "x$ignore_f" = xf ; then
1957                  case $extn in                      extn=`echo $sf | $AWK -F. '{print $NF}'`
1958                      F)                      case $extn in
1959                          echo    " \\"  >> srclist.inc                          F)
1960                          echo -n " $sf" >> srclist.inc                              echo    " \\"  >> srclist.inc
1961                          ;;                              printf " $sf" >> srclist.inc
1962                      F90)                              ;;
1963                          echo    " \\"  >> f90srclist.inc                          F90)
1964                          echo -n " $sf" >> f90srclist.inc                              echo    " \\"  >> f90srclist.inc
1965                          ;;                              printf " $sf" >> f90srclist.inc
1966                      c)                              ;;
1967                          echo    " \\"  >> csrclist.inc                          c)
1968                          echo -n " $sf" >> csrclist.inc                              echo    " \\"  >> csrclist.inc
1969                          ;;                              printf " $sf" >> csrclist.inc
1970                      h)                              ;;
1971                          echo    " \\"  >> hlist.inc                          h)
1972                          echo -n " $sf" >> hlist.inc                              echo    " \\"  >> hlist.inc
1973                          ;;                              printf " $sf" >> hlist.inc
1974                      flow)                              ;;
1975                          echo    " \\"  >> ad_flow_files.inc                          flow)
1976                          echo -n " $sf" >> ad_flow_files.inc                              echo    " \\"  >> ad_flow_files.inc
1977                          ;;                              printf " $sf" >> ad_flow_files.inc
1978                  esac                              ;;
1979                        esac
1980                    fi
1981              fi              fi
1982          fi          fi
1983      done      done
# Line 1425  echo "" >> f90srclist.inc Line 1995  echo "" >> f90srclist.inc
1995  echo "" >> hlist.inc  echo "" >> hlist.inc
1996  echo "" >> ad_flow_files.inc  echo "" >> ad_flow_files.inc
1997    
1998  if test -e $MAKEFILE ; then  if test -f $MAKEFILE ; then
1999      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
2000  fi  fi
2001  echo "  Writing makefile: $MAKEFILE"  echo "  Writing makefile: $MAKEFILE"
# Line 1434  echo "#    $MACHINE" >> $MAKEFILE Line 2004  echo "#    $MACHINE" >> $MAKEFILE
2004  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
2005  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
2006  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
2007  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
2008  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
2009  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    ${THISUSER}@${THISHOST}:${THISCWD}" >> $MAKEFILE
2010    
2011  EXE_AD=$EXECUTABLE"_ad"  EXE_AD=$EXECUTABLE"_ad"
2012  EXE_FTL=$EXECUTABLE"_ftl"  EXE_FTL=$EXECUTABLE"_ftl"
# Line 1482  ENABLED_PACKAGES = ${ENABLED_PACKAGES} Line 2052  ENABLED_PACKAGES = ${ENABLED_PACKAGES}
2052  DISABLED_PACKAGES = ${DISABLED_PACKAGES}  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2053    
2054  # These files are created by Makefile  # These files are created by Makefile
2055  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
2056    
2057  EOF  EOF
2058    
# Line 1501  KPP = ${KPP} Line 2071  KPP = ${KPP}
2071  FC = ${FC}  FC = ${FC}
2072  # Fortran compiler  # Fortran compiler
2073  F90C = ${F90C}  F90C = ${F90C}
2074    # C compiler
2075    CC = ${CC}
2076  # Link editor  # Link editor
2077  LINK = ${LINK}  LINK = ${LINK} ${LDADD}
2078    
2079  # Defines for CPP  # Defines for CPP
2080  DEFINES = ${DEFINES}  DEFINES = ${DEFINES}
# Line 1523  CFLAGS = ${CFLAGS} Line 2095  CFLAGS = ${CFLAGS}
2095  NOOPTFILES = ${NOOPTFILES}  NOOPTFILES = ${NOOPTFILES}
2096  NOOPTFLAGS = ${NOOPTFLAGS}  NOOPTFLAGS = ${NOOPTFLAGS}
2097  # Flags and libraries needed for linking  # Flags and libraries needed for linking
2098  LIBS = ${LIBS} \$(XLIBS)  LIBS = ${LIBS}
2099  # Name of the Mekfile  # Name of the Mekfile
2100  MAKEFILE=${MAKEFILE}  MAKEFILE=${MAKEFILE}
2101    
# Line 1534  cat csrclist.inc      >> $MAKEFILE Line 2106  cat csrclist.inc      >> $MAKEFILE
2106  cat f90srclist.inc    >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
2107  cat hlist.inc         >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
2108  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
2109  echo               >> $MAKEFILE  echo >> $MAKEFILE
2110  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
2111  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F90=.'$FS90')' >> $MAKEFILE
2112  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
2113    echo >> $MAKEFILE
2114    echo '.SUFFIXES:' >> $MAKEFILE
2115    echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
2116  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
2117  rm -f ad_flow_files.inc  rm -f ad_flow_files.inc
2118    
2119  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2120    
 .SUFFIXES:  
 .SUFFIXES: .o .f .p .F .c .F90 .f90  
   
2121  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2122  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
2123          @echo Creating \$@ ...          @echo Creating \$@ ...
2124          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2125  depend:  depend:
2126          @make links          @make links
2127          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
2128          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2129            -rm -f makedepend.out
2130    
2131    lib: libmitgcmuv.a
2132    
2133    libmitgcmuv.a: \$(OBJFILES)
2134            ar rcv libmitgcmuv.a \$(OBJFILES)
2135    
2136  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2137    
# Line 1565  output.txt: \$(EXECUTABLE) Line 2142  output.txt: \$(EXECUTABLE)
2142          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2143    
2144  clean:  clean:
2145          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2146  Clean:  Clean:
2147          @make clean          @make clean
2148          @make cleanlinks          @make cleanlinks
# Line 1576  CLEAN: Line 2153  CLEAN:
2153          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2154          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2155          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2156          -rm -f \$(EXECUTABLE) output.txt          -rm -f \$(EXECUTABLE) output.txt STD*
2157    
2158  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2159  makefile:  makefile:
2160          $THIS_SCRIPT $@          $THIS_SCRIPT $G2ARGS
2161  cleanlinks:  cleanlinks:
2162          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
2163    
2164  # Special targets ($SPECIAL_FILES) which are create by make  # Special targets (SPECIAL_FILES) which are create by make
2165  ${PACKAGES_DOT_H}:  ${PACKAGES_DOT_H}:
2166          @echo Creating \$@ ...          @echo Creating \$@ ...
2167          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
2168  AD_CONFIG.h:  AD_CONFIG.h:
2169          @echo Creating \$@ ...          @echo Creating \$@ ...
2170          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
2171  FC_NAMEMANGLE.h:  FC_NAMEMANGLE.h:
2172          @echo Creating \$@ ...          @echo Creating \$@ ...
2173          echo "$FC_NAMEMANGLE" > \$@          echo "$FC_NAMEMANGLE" > \$@
2174    
2175  # The normal chain of rules is (  .F - .f - .o  )  BUILD_INFO.h:
2176  .F.f:          @echo Creating \$@ ...
2177    EOF
2178    
2179    test ! "x$THISVER" = x  && echo "       -echo \"#define THISVER '$THISVER'\" > \$@"   >> $MAKEFILE
2180    test ! "x$THISUSER" = x && echo "       -echo \"#define THISUSER '$THISUSER'\" >> \$@" >> $MAKEFILE
2181    test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2182    test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2183    
2184    cat >>$MAKEFILE <<EOF
2185    
2186    # The normal chain of rules is (  .F - .$FS - .o  )
2187    
2188    ## This nullifies any default implicit rules concerning these two file types:
2189    ## %.o : %.F
2190    
2191    .F.$FS:
2192          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2193  .f.o:  .$FS.o:
2194          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2195  .F90.f90:  .F90.$FS90:
2196          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2197  .f90.o:  .$FS90.o:
2198          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2199  .c.o:  .c.o:
2200          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) -c \$<
2201    
2202  # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2203  .F.p:  .F.p:
2204          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2205  .p.f:  .p.$FS:
2206          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
2207    
2208  #=========================================  #=========================================
# Line 1637  done Line 2229  done
2229    
2230  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
2231  echo >> $MAKEFILE  echo >> $MAKEFILE
2232  echo -n "AD_FILES = " >> $MAKEFILE  printf "AD_FILES = " >> $MAKEFILE
2233  AD_FILES=`cat ad_files`  AD_FILES=`cat ad_files`
2234  for i in $AD_FILES ; do  for i in $AD_FILES ; do
2235      echo    " \\" >> $MAKEFILE      echo    " \\" >> $MAKEFILE
2236      echo -n " $i" >> $MAKEFILE      printf " $i" >> $MAKEFILE
2237  done  done
2238  echo >> $MAKEFILE  echo >> $MAKEFILE
2239  rm -f ad_files  rm -f ad_files
# Line 1650  cat >>$MAKEFILE <<EOF Line 2242  cat >>$MAKEFILE <<EOF
2242    
2243  # ... AD ...  # ... AD ...
2244  adall: ad_taf  adall: ad_taf
2245  adtaf: ad_taf_output.f  adtaf: ad_taf_output.$FS
2246  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.$FS
2247    
2248  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)
2249          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2250          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2251          -rm -f ad_config.template          -rm -f ad_config.template
2252          @make \$(F77FILES)          @make \$(F77FILES)
2253          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2254          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.$FS
2255    
2256  ad_taf_output.f: ad_input_code.f  ad_taf_output.$FS: ad_input_code.$FS
2257          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2258          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2259    
2260  adtafonly:  adtafonly:
2261          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2262          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2263    
2264  ad_taf: ad_taf_output.o \$(OBJFILES)  ad_taf: ad_taf_output.o \$(OBJFILES)
2265          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2266    
2267  ad_tamc_output.f: ad_input_code.f  ad_tamc_output.$FS: ad_input_code.$FS
2268          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS
2269          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.$FS
2270    
2271  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
2272          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
2273    
2274    adonlyfwd:
2275            patch < \$(TOOLSDIR)/ad_taf_output.f.onlyfwd.diff
2276    
2277    adtrick:
2278            patch < \$(TOOLSDIR)/ad_taf_output.f.adtrick.diff
2279    
2280  # ... FTL ...  # ... FTL ...
2281  ftlall: ftl_taf  ftlall: ftl_taf
2282  ftltaf: ftl_taf_output.f  ftltaf: ftl_taf_output.$FS
2283  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.$FS
2284    
2285  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)
2286          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2287          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2288          -rm -f ftl_config.template          -rm -f ftl_config.template
2289          @make \$(F77FILES)          @make \$(F77FILES)
2290          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2291          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.$FS
2292    
2293  ftl_taf_output.f: ftl_input_code.f  ftl_taf_output.$FS: ftl_input_code.$FS
2294          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2295          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2296    
2297  ftltafonly:  ftltafonly:
2298          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2299          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2300    
2301  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
2302          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
2303    
2304  ftl_tamc_output.f: ftl_input_code.f  ftl_tamc_output.$FS: ftl_input_code.$FS
2305          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.$FS
2306          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.$FS
2307    
2308  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2309          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
2310    
2311    
2312  # ... SVD ...  # ... SVD ...
2313  svdtaf: ad_taf_output.f ftl_taf_output.f  svdtaf: ad_taf_output.$FS ftl_taf_output.$FS
2314  svdall: svd_taf          @echo "--->>> Only ran TAF to generate SVD code!    <<<---"
2315            @echo "--->>> Do make svdall afterwards to compile. <<<---"
2316    svdall: svd_touch svd_taf
2317    
2318  svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)  svd_taf: \$(OBJFILES)
2319          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
2320    
2321            @echo "--->>> Only COMPILE svd code! <<<---"
2322            @echo "--->>> Assumes you previously <<<---"
2323            @echo "--->>> did make svdtaf        <<<---"
2324    
2325    svd_touch:
2326            @echo "--->>> Only COMPILE svd code! <<<---"
2327            @echo "--->>> Assumes you previously <<<---"
2328            @echo "--->>> did make svdtaf        <<<---"
2329            touch ad_taf_output.$FS ftl_taf_output.$FS
2330            \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.$FS
2331            \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.$FS
2332            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2333            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2334            -rm -f ftl_config.template
2335    
2336  #=========================================  #=========================================
2337    
# Line 1735  for i in $KPPFILES ; do Line 2348  for i in $KPPFILES ; do
2348      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2349          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2350      fi      fi
2351      echo "$base.f: $base.p" >> $MAKEFILE      echo "$base.$FS: $base.p" >> $MAKEFILE
2352  done  done
2353    
2354  echo "  Making list of NOOPTFILES"  echo "  Making list of NOOPTFILES"
# Line 1745  for i in $NOOPTFILES ; do Line 2358  for i in $NOOPTFILES ; do
2358      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2359          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2360      fi      fi
2361      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.$FS" >> $MAKEFILE
2362      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2363  done  done
2364    
# Line 1759  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 2372  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
2372  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
2373    
2374  # Create special header files  # Create special header files
2375  $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"  $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
2376  if test ! -f $PACKAGES_DOT_H ; then  if test ! -f $PACKAGES_DOT_H ; then
2377      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2378  else  else
# Line 1773  else Line 2386  else
2386      fi      fi
2387  fi  fi
2388  if test ! -f AD_CONFIG.h ; then  if test ! -f AD_CONFIG.h ; then
2389      $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h      $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
2390  fi  fi
2391    
2392    
2393  #  Write the "state" for future records  #  Write the "state" for future records
2394  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
2395      echo -n "" > genmake_state      printf "" > genmake_state
2396      for i in $gm_state ; do      for i in $gm_state ; do
2397          t1="t2=\$$i"          t1="t2=\$$i"
2398          eval $t1          eval $t1

Legend:
Removed from v.1.63  
changed lines
  Added in v.1.134

  ViewVC Help
Powered by ViewVC 1.1.22